'use strict';

exports.__esModule = true;

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _broadcast(componentName, eventName, params) {
  this.$children.forEach(function (child) {
    var name = _config2.default.prefix + child.$options.componentName;

    if (name === componentName) {
      child.$emit.apply(child, [eventName].concat(params));
    } else {
      _broadcast.apply(child, [componentName, eventName].concat([params]));
    }
  });
}
exports.default = {
  methods: {
    dispatch: function dispatch(componentName, eventName, params) {
      componentName = _config2.default.prefix + componentName;
      var parent = this.$parent || this.$root;
      var name = _config2.default.prefix + parent.$options.componentName;

      while (parent && (!name || name !== componentName)) {
        parent = parent.$parent;

        if (parent) {
          name = _config2.default.prefix + parent.$options.componentName;
        }
      }
      if (parent) {
        parent.$emit.apply(parent, [eventName].concat(params));
      }
    },
    broadcast: function broadcast(componentName, eventName, params) {
      componentName = _config2.default.prefix + componentName;
      _broadcast.call(this, componentName, eventName, params);
    }
  }
};